 #include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <string.h>
/*#include <winsock.h>*/
#include <mysql/mysql.h>

bool demareConnection(MYSQL *connection);
int loginApp(MYSQL *connection);
int misAJourElement(MYSQL *connection, const char *requete);
void affichageResult(MYSQL *connection, const char *requete);
int elementExist(MYSQL *connection, const char*argumentRef, const char *table, const char*champComp, const char *elementCh);
void gestionBibliotheque(MYSQL *connection);
void gestionUtilisateur(MYSQL *connection);
void gestionRapports(MYSQL *connection);
unsigned int resultat_trouve;
char chaine[];

int main()
{
    MYSQL con;

    if( !demareConnection(&con))
    {
        printf("Erreur lors de la connection a la BDD !!!\n");
        system("pause");
        exit(1);
    }

    if(!loginApp(&con))
    {
        exit(1);
        mysql_close(&con); 

    }


    int tour = 0;

    do
    {
        system("clear");
        printf("                    LA BIBLIOTHEQUE \n");
        printf("    -----------------------------------------------------------------\n\n");
        printf("        1. Pour la Gestion de la Bibliotheque ............... \n");
        printf("        2. Pour la Gestion des utilisateurs ................. \n");
        printf("        3. Pour la Gestion des rapports ..................... \n");
        printf("        4. Pour quitter le programme ........................ \n\n");
        printf("**********************************************************************\n");
        printf("    Tapez votre choix : ");
        scanf("%d", &tour);

        switch(tour)
        {
            case 1 :
                system("clear");
                gestionBibliotheque(&con);
                break;
            case 2 :
                gestionUtilisateur(&con);
                break;
            case 3:
                system("clear");
                gestionRapports(&con);
            case 4:
                break;
            default :
                printf(" Erreur de saisi !!!\n");
                break;
        }

    } while (tour != 4);
    mysql_close(&con);
    printf(" Fin programme ! \n");
    return EXIT_SUCCESS;
}

bool demareConnection(MYSQL *connection)
{

    mysql_init(connection);
    mysql_options(connection, MYSQL_READ_DEFAULT_GROUP, "option");

    if(mysql_real_connect(connection, "localhost","root","","GestionBibliothèque",0,"NULL",0))
        return true;
    else
        return false;
}

int misAJourElement(MYSQL *connection, const char* requete)
{
    int b;
    if(b = mysql_query(connection, requete))
    {
        printf("L'operation a ete effectue sans probleme !\n");
        return b;
    }
    else if(b == 0)
    {
       printf("Impossible de trouve les elements cibles");
       return 0;
    }

     printf("Une erreur s'est produit dans la requete !\n");
     return -1;
}

void affichageResult(MYSQL *connection, const char *requete)
{
    mysql_query(connection, requete);
    MYSQL_RES *resultat = NULL;
    MYSQL_ROW ligne;

    unsigned int i = 0;
    unsigned int nombre_champ = 0;

    resultat = mysql_store_result(&connection);
    nombre_champ = mysql_num_fields(resultat);
    while((ligne = mysql_fetch_row(resultat)))
    {
        unsigned int *taille;

        taille = mysql_fetch_lengths(resultat);

        for(i = 0; i < nombre_champ; i++)
        {
            printf("[ %.*s ]", (int) taille[i], ligne[i] ? ligne[i] : "NULL");
        }
        resultat_trouve = 1;
        printf("\n");
    }
    mysql_free_result(resultat);
}

int elementExist(MYSQL *connection, const char*argumentRef, const char *table, const char*champComp, const char *elementCh)
{
    char requete[300];
    sprintf(requete, "SELECT %s from %s where %s='%s'",argumentRef, table, champComp, elementCh);
    mysql_query(connection, requete);
    MYSQL_RES *resultat = NULL;
    MYSQL_ROW ligne;
    unsigned int nombre_ligne = 0;

    resultat = mysql_store_result(connection);
    nombre_ligne = mysql_num_rows(resultat);
    ligne = mysql_fetch_row(resultat);

    if (nombre_ligne != 0)
    {
        ligne = mysql_fetch_row(resultat);
        sprintf(chaine, "%s",ligne[0]);
        mysql_free_result(resultat);
        return 1;
    }
    else
    {
        mysql_free_result(resultat);
        return 0;
    }
}

int loginApp(MYSQL *connection)
{
    unsigned int i = 0;

    char nomUser[] = "", matricule[] = "",req[] ="";

    MYSQL_RES *resultat;
    MYSQL_ROW ligne;
    int nbLing = 0;


    mysql_query(connection, "SELECT * FROM `CarteAcces`");
    resultat = mysql_store_result(connection);
    nbLing = mysql_num_rows(resultat);
    mysql_query(connection,req);

    if(!nbLing)
    {
        char nom[20] ="", postNom[20]= "", sexe[3] ="", matricule[15] = "", req2[] ="";

        printf("VEUILLEZ INSCRIRE VOS INFORMATIONS\n");
        printf("------------------------------------\n");
        printf("Note : Ceux informations vous serverons \n\tlors de votre prochaine !\n\n");
        printf("Tapez votre nom : ");
        scanf("%s", nom);
        printf("Tapez votre PostNom : ");
        scanf("%s", postNom);
        printf("Tapez votre sexe : ");
        scanf("%d", sexe);
        printf("Tapez votre matricule : ");
        scanf("%s", matricule);

        sprintf(req,"INSERT INTO `CarteAcces`(nom,postnom,matricule,sexe) values('%s','%s','%s','%s')",nom,postNom,matricule,sexe);
        sprintf(req2,"INSERT INTO `Membre`(nom,postnom,sexe) values('%s','%s','%s')",nom,postNom,sexe);
        misAJourElement(connection, req);
        misAJourElement(connection, req2);

        return 1;
    }

    do
    {
        printf("INSERER VOS INFORMATIONS DE CONNEXTION\n");
        printf("----------------------------------------\n");
        printf("Tapez votre nom : ");
        scanf("%s", nomUser);
        printf("Tapez votre matricule :");
        scanf("%s", matricule);

        sprintf(req, "SELECT nom,matricule FROM CarteAcces WHERE( nom ='%s' AND matricule='%s')", nomUser, matricule);

        resultat = mysql_store_result(connection);
        ligne = mysql_fetch_row(resultat);
        if(ligne)
        {
            return 1;
        }
        else
        {
                printf("Les identfiants fournies sont incorrect !\n");
        }
        system("Clear");
        i++;
    }while(i < 3);
    printf("Problem : 3 Tentative de connection, echec !!!\n");
    system("pause");
    return 0;
}


void gestionBibliotheque( MYSQL *connection)
{
    int choix  = 0, choix2 = 0, choix3 = 0;
    char requete[300];
    char nom[20]="", postNom[20]="", sexe[2]="", nomAuteur[20]="", nomLivre[20] = "", categorieLivre[20] = "", descriptionLivre[20] = "";
    char domaineScient[20]= "";
    do
    {
        system("clear");
        printf("GESTION BIBLIOTHEQUE\n");
        printf("----------------------\n\n");
        printf("    1. Pour gestion des Documents de la bibliotheque ***\n");
        printf("    2. Pour gestion des membres de la bibliotheque *****\n");
        printf("    3. Pour gestion des empruts Documents **************\n");
        printf("    4. Pour quitter ce menu ****************************\n");
        printf("-----------------------------------------------------------\n");
        printf("Tapez votre choix : ");
        scanf("%d", &choix);

        switch(choix)
        {
            case 1:
                system("clear");
                printf("DOCUMENTS\n");
                printf("-----------\n");
                printf("  1. Pour voir les documents selon l'auteur \n");
                printf("  2. Pour voir les documents \n\t\tselon leurs categorie (livre,TFC,Memoire,Article,Dictionnaire \n");
                printf("  3. Pour voir tous les documents ");
                printf("  4. Pour ajouter un ajouter \n");
                printf("  5. Continue sans rien faire \n");
                printf("-----------------------------------------------------\n");
                printf("Tapez votre choix : ");
                scanf("%d", &choix2);
                if( choix2 == 1)
                {
                    printf("\n\nTapez le nom de l'auteur : ");
                    scanf("%s", nomAuteur);
                    printf(" N | Nom document | Domaine | Auteur \n");
                    printf("-------------------------------------------\n");
                    sprintf(requete, "SELECT IdDoc, Titre, Domaine, Auteur from Document where Auteur = '%s'",nomAuteur);
                    affichageResult(connection, requete);
                }
                else if(choix2 == 2)
                {
                    printf("\n\nTapez le nom de la categorie du livre (livre, TFC, Memoire, Aticle...) : ");
                    scanf("%s", categorieLivre);

                    sprintf(requete, "SELECT IdDoc,Titre,Domaine,categorie, Auteur from Document where categorie = '%s'",categorieLivre);

                    printf(" N | Nom document | Domaine | Categorie | Auteur \n");
                    printf("------------------------------------------\n");
                    affichageResult(connection, requete);
                }
                else if( choix2 == 3)
                {
                    sprintf(requete, "SELECT IdDoc,Titre,Domaine,categorie, Auteur from Document ");

                    printf(" N | Nom document | Domaine | Categorie | Auteur \n");
                    printf("------------------------------------------\n");
                    affichageResult(connection, requete);
                }
                else if( choix2 == 4)
                {
                    char requete012[300] ="";
                    printf("\n\nENREGISTREMENT D'UN NOUVEAU DOCUMENT|LIVRE\n");
                    printf("-----------------------------------\n");
                    printf("Tapez le nom du document : ");
                    scanf("%s", nomLivre);
                    printf("Description sur le livre :");
                    scanf("%s", descriptionLivre);
                    printf("Tapez le nom de l'auteur du document :");
                    scanf("%s", nomAuteur);
                    printf("Tapez le domaine scientifique du document : ");
                    scanf("%s", domaineScient);

                    printf("choissisez la categorie du document : ");
                    printf("    1. Livre \n    2. Memoire \n   3. Article \n   4. TFC \n   5. Dictonnaire\n");
                    scanf("%d", &choix3);

                    if(choix3 == 1)
                    {
                        sprintf(categorieLivre,"Livre");
                    }
                    else if(choix3 == 2)
                    {
                        sprintf(categorieLivre,"Memoire");
                    }
                    else if(choix3 == 3)
                    {
                        sprintf(categorieLivre,"Article");
                    }
                    else if(choix3 == 4)
                    {
                        sprintf(categorieLivre,"TFC");
                    }
                    else if(choix3 == 5)
                    {
                        sprintf(categorieLivre,"Dictionnaire");
                    }
                    else
                    {
                        printf(" Information sournies avec erreur ! \n");
                        system("pause");
                        break;
                    }

                    sprintf(requete012,"INSERT INTO Document (libelle, Titre, Domaine, Auteur, categorie) values('%s', '%s', '%s', '%s', '%s')",descriptionLivre, nomLivre,domaineScient, nomAuteur, categorieLivre);
                    misAJourElement(connection, requete012);
                }

                break;
            case 2:
                system("clear");
                printf("MEMBRES\n");
                printf("------------\n\n");
                printf("  1. Pour afficher tous les membre\n");
                printf("  2. pour recherchee un membre  \n");
                printf("  3. pour supprimer un membre \n");
                printf("  4. pour ajouter un membre \n");
                printf("-----------------------------------\n");
                printf("Tapez votre choix : ");
                scanf("%d", &choix2);
                if(choix2 == 1)
                {
                    system("clear");
                    sprintf(requete, "SELECT idMem, nom, postnom from `Membre`");
                    printf(" N  |   Nom membre |   Post Nom   | \n");
                    affichageResult(connection, requete);
                }
                else if(choix2 == 2)
                {
                    system("clear");
                    printf("Tapez le nom du membre recherche : ");
                    scanf("%s", nom);
                    sprintf(requete,"SELECT idMem, nom, postnom, sexe from `Membre` where nom ='%s'", nom);
                    printf("  N | Nom Membre | Post Nom | Sexe |\n");
                    printf("------------------------------------------\n");
                    affichageResult(connection, requete);
                }
                else if(choix2 == 3)
                {
                    system("clear");
                    sprintf(requete, "SELECT idMem, nom, postnom, sexe from `Membre`");
                    printf("        LA LISTE DES MEMBRES \n");
                    printf("---------------------------------\n\n");
                    printf("  N | NOM M | POST NOM | SEXE \n");
                    printf("----------------------------------\n");
                    affichageResult(connection, requete);
                    printf("---------------------------");
                    printf("Tapez le nom du membre pour suppression : ");
                    scanf("%s",nom);
                    sprintf(requete,"DELETE FROM `Membre` where nom ='%s'", nom);
                    misAJourElement(connection, requete);
                }
                else if(choix2 == 4)
                {
                    system("clear");
                    printf("            ENREGISTREMENT D'UN NOUVEAU MEMBRE\n");
                    printf("-----------------------------------------------------\n\n");
                    printf("Tapez le Nom du nouveau membre : ");
                    scanf("%s", nom);
                    printf("Tapez le Post Nom du nouveau membre : ");
                    scanf("%s", postNom);
                    printf("Tapez le sexe du nouveau membre : ");
                    scanf("%s", sexe);
                    sprintf(requete,"INSERT INTO `Membre`(nom,postnom,sexe) values('%s','%s','%s')",nom,postNom,sexe);
                    misAJourElement(connection, requete);
                }
                system("pause");
                break;
            case 3 :
                system("clear");
                int choix01 = 0;
                char nomL[20];
                system("clear");
                printf("             GESTION DES EMPRUNTS DOCUMENTS \n");
                printf("----------------------------------------------------\n");
                printf("   1. Operation d'emprunts document ............\n");
                printf("   2. Operation : voir le document emprunte ....\n");
                printf("   3. Operation : Quitter le menu ..............\n");
                printf("---------------------------------------------------\n");
                scanf("%d", &choix01);

                system("clear");
                if (choix01 == 1)
                {
                    sprintf(requete, "SELECT idDoc, titre from Document");
                    printf("          LISTE DE DOCUMENTS EXISTANT \n");
                    printf("----------------------------------------------\n");
                    affichageResult(connection, requete);
                    if (resultat_trouve == 1)
                    {
                        char dateEm[15] ="", dateRem[15] ="", matriculeEm[15] ="", idMembre[10]= "";
                        printf("\n\nTapez le nom du document : ");
                        scanf("%s", nomL);
                        printf("Tapez le nom du membre qui vient emprunte : \n");
                        scanf("%s", nom);
                        if ( elementExist(connection, "Doc","Document","Titre",&nomL ) && elementExist(connection, "idMem","Membre", "nom", &nom))
                        {
                            printf("Tapez la date d'aujourd'hui : ");
                            scanf("%s", dateEm);
                            printf("Tapez la date de remise : ");
                            scanf("%s", dateRem);
                            printf("Tapez le matricule de l'emprunt : ");
                            scanf("%s", matriculeEm);
                            char requete01[300] ="";
                            sprintf(requete01, "INSERT INTO Emprunt(idMem, matricule, dateEmprunt, dateRestitution ) values('%s','%s','%s','%s')",chaine, matriculeEm, dateEm, dateRem );
                            misAJourElement(connection, &requete01 );
                        }
                        else
                        {

                            printf("\n Les elements cible sont introuvables !!!\n");
                        }
                    }
                    else
                    {
                        printf("Aucun document n'a ete trouve dans la bibliotheque \n");
                    }
                }
                else if(choix == 2)
                {
                    printf("         LISTE COMPLET DES DOCUMENTS EN EMPRUNT  \n");
                    printf("----------------------------------------------------\n");
                    printf("  N | NOM DOCS | DATE EMPRUT | DATE RES | idMem MEMBRE \n");
                    printf("------------------------------------------------------\n");
                    affichageResult(connection, "SELECT idEm, dateEm, dateRes, idMem FROM emprunt");
                }
                break;
            case 4 :
                break;
            default:
                printf(" Erreur de saisi ...\n");
                break;
        }
    }while( choix != 4);
}

void gestionUtilisateur(MYSQL *connection)
{
    int choix = 0;
    char requete[300];
    char reqe[300];

    do
    {
        system("clear");
        printf("GESTION UTILISATEUR \n");
        printf("----------------------\n\n");
        printf("  1. Voir les utilisateur actuels ***\n");
        printf("  2. Ajouter un utilisateur *********\n");
        printf("  3. Suprimmer un utilisateur *******\n");
        printf("  4. Quitter le menu actuel *********\n");
        printf("---------------------------------------\n");
        scanf("%d", &choix);

        switch(choix)
        {
            case 1 :
                system("clear");
                sprintf(requete, "SELECT idCar,nom,postnom,matricule from CarteAcces");
                printf("LISTE DES UTILISATEURS\n");
                printf("------------------------\n");
                printf(" N | NOM UT | POSTNOM | SEXE | MATRICULE\n");
                printf("----------------------------------------------\n");
                affichageResult(connection, requete);
                break;
            case 2 :
                system("clear");
                char nom[20] ="", postNom[20]= "", sexe[3] ="", matricule[15] = "", req2[300] ="";
                system("clear");
                printf("VEUILLEZ INSCRIRE LES INFORMATIONS DE L'UTILISATEUR \n");
                printf("-------------------------------------------------------------\n");
                printf("Note : Ceux informations vous serverons \n\tlors de votre prochaine !\n\n");
                printf("Tapez votre nom : ");
                scanf("%s", nom);
                printf("Tapez votre PostNom : ");
                scanf("%s", postNom);
                printf("Tapez votre sexe : ");
                scanf("%s", sexe);
                printf("Tapez votre matricule : ");
                scanf("%s", matricule);

                sprintf(requete,"INSERT INTO `CarteAcces`(nom,postnom,matricule,sexe) values('%s','%s','%s','%s')",nom,postNom,matricule,sexe);
                sprintf(req2,"INSERT INTO `Membre`(nom,postnom,sexe) values('%s','%s','%s')",nom,postNom,sexe);
                misAJourElement(connection, requete);
                misAJourElement(connection, req2);
                break;
            case 3 :
                system("clear");
                sprintf(requete, "SELECT *from `CarteAcces`");
                printf("      LISTE DES UTILISATEURS\n");
                printf("----------------------------------\n");
                printf(" N | Nom | Post Nom | Matricule \n");
                printf("-----------------------------------\n");
                affichageResult(connection, requete);
                printf("------------------------------------\n\n");
                printf("Tapez le nom de l'utilisateur a supprimer : ");
                scanf("%s", nom);

                sprintf(requete,"DELETE from `CarteAcces` where nom ='%'", nom);
                misAJourElement(connection, requete);
                break;
        }
    }while(choix != 4);
}

void gestionRapports(MYSQL *con)
{
    int choix = 0;

    do
    {
        system("clear");
        printf("          GESTION DES RAPPORTS  \n");
        printf(" --------------------------------------\n\n");
        printf("  1. Pour voir la liste des membres **********\n");
        printf("  2. Pour voir la liste des livres empruntes *\n");
        printf("  3. Pour quitter ce menu ********************\n");
        printf("------------------------------------------------\n");
        scanf("%d", &choix);

        switch(choix)
        {
            system("clear");
            case 1 :
                printf("         LISTE COMPLET DES MEMBRES  \n");
                printf("------------------------------------------\n");
                printf("  N | NOM MEMBRE | POST NOM | SEXE \n");
                printf("-----------------------------------------\n");
                affichageResult(con, "SELECT idm, nom, postnom, sexe FROM Membre");
                break;

            case 2 :
                printf("         LISTE COMPLET DES DOCUMENTS EN EMPRUNT  \n");
                printf("----------------------------------------------------\n");
                printf("  N | NOM DOCS | DATE EMPRUT | DATE RES | idMem MEMBRE \n");
                printf("------------------------------------------------------\n");
                affichageResult(con, "SELECT idEm, dateEm, dateRes, idMem FROM emprunt");
                break;
        }

    }while(choix != 3);
}





































/*int main(void)
{
    MYSQL con;


    mysql_init(&con);


    mysql_options(&con, MYSQL_READ_DEFAULT_GROUP, "option");

    if(mysql_real_connect(&con, "localhost","root","","gestionatmosphere",3306,"NULL",0))
    {
        printf("Connexion reussi !!! \n");
        mysql_query(&con, "SELECT *from troposphere");
        MYSQL_RES *resultat = NULL;

        MYSQL_ROW row;

        unsigned int i = 0;
        unsigned int num_champ = 0;

        resultat = mysql_store_result(&con);
        num_champ = mysql_num_fields(resultat);
        while((row = mysql_fetch_row(resultat)))
        {
            unsigned int *lenght;

            lenght = mysql_fetch_lengths(resultat);

            for(i = 0; i < num_champ; i++)
            {
                printf("[%.*s]", (int) lenght[i], row[i] ? row[i] : "NULL");
            }
            printf("\n");
        }
        mysql_free_result(resultat);

        mysql_close(&con);
    }
    else
    {
        printf("la connexion a echoue !!!");
    }

    /*MYSQL *con = mysql_init(NULL);

    if(NULL == con)
    {
        printf("Erreur d'initialisation \n");
        return 1;
    }
    if( NULL == mysql_real_connect( con, "localhost", "","", NULL, 0, NULL,0))
    {
        printf("Erreur de connexion !");
        printf("Type Erreur : %s", mysql_errno(con));
        return 1;
    }
    if(mysql_query(con, "show databases"))
    {
        printf("Erreur :  %s", mysql_errno(con));
        mysql_close(con);
        return 1;
    }
    MYSQL_RES *res = mysql_store_resultat(con);

    mysql_free_resultat(con);
    mysql_close(con);
    return 0;
}*/










/*if(mysql_real_connect(&con, "localhost","root","","gestionatmosphere",3306,"NULL",0))
    {
        printf("Connexion reussi !!! \n");
        mysql_query(&con, "SELECT *from troposphere");
        MYSQL_RES *resultat = NULL;

        MYSQL_ROW row;

        unsigned int i = 0;
        unsigned int num_champ = 0;

        resultat = mysql_store_result(&con);
        num_champ = mysql_num_fields(resultat);
        while((row = mysql_fetch_row(resultat)))
        {
            unsigned int *lenght;

            lenght = mysql_fetch_lengths(resultat);

            for(i = 0; i < num_champ; i++)
            {
                printf("[%.*s]", (int) lenght[i], row[i] ? row[i] : "NULL");
            }
            printf("\n");
        }
        mysql_free_result(resultat);

        mysql_close(&con);
    }*/
